<script setup lang="ts">
import { reactive, onMounted, ref } from "vue";
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { Modal } from "bootstrap";
import { useResourceStore } from "@/stores/resources";
import type { ResourceVersionIn, ResourceOut } from "@/client/types.gen";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { Tooltip } from "bootstrap";

const resourceRepository = useResourceStore();

const resourceUpdateForm = ref<HTMLFormElement | undefined>(undefined);

const resourceUpdate = reactive<ResourceVersionIn>({
  release: "",
});

const formState = reactive<{
  validated: boolean;
  loading: boolean;
}>({
  validated: false,
  loading: false,
});

const props = defineProps<{
  modalId: string;
  resource: ResourceOut;
}>();

let updateResourceModal: Modal | null = null;

function updateResource() {
  formState.validated = true;
  resourceUpdate.release = resourceUpdate.release.trim();
  if (resourceUpdateForm.value?.checkValidity()) {
    formState.loading = true;
    resourceRepository
      .updateResource(props.resource.resource_id, resourceUpdate)
      .then(() => {
        updateResourceModal?.hide();
        resourceUpdate.release = "";
        formState.validated = false;
      })
      .finally(() => {
        formState.loading = false;
      });
  }
}

function modalClosed() {
  formState.validated = false;
}

onMounted(() => {
  updateResourceModal = new Modal("#" + props.modalId);
  new Tooltip("#tooltip-update-resource-release");
});
</script>

<template>
  <bootstrap-modal
    :modal-id="modalId"
    static-backdrop
    modal-label="Update Resource Modal"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template #header>
      Update Resource <b>{{ props.resource.name }}</b></template
    >
    <template #body>
      <form
        id="resourceUpdateForm"
        ref="resourceUpdateForm"
        :class="{ 'was-validated': formState.validated }"
      >
        <div class="mb-3">
          <label for="resourceUpdateReleaseInput" class="form-label">
            Release
          </label>
          <div class="input-group">
            <div class="input-group-text">
              <font-awesome-icon icon="fa-solid fa-tag" />
            </div>
            <input
              id="resourceUpdateReleaseInput"
              v-model="resourceUpdate.release"
              class="form-control"
              required
              minlength="3"
              maxlength="32"
              placeholder="Next release name"
            />
            <div
              id="tooltip-update-resource-release"
              class="input-group-text hover-info"
              data-bs-toggle="tooltip"
              data-bs-title="The name of the next resource version"
            >
              <font-awesome-icon icon="fa-solid fa-circle-question" />
            </div>
          </div>
        </div>
      </form>
    </template>
    <template #footer>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
      <button
        type="submit"
        form="resourceUpdateForm"
        class="btn btn-primary"
        :disabled="formState.loading || !props.resource.resource_id"
        @click.prevent="updateResource"
      >
        <span
          v-if="formState.loading"
          class="spinner-border spinner-border-sm"
          role="status"
          aria-hidden="true"
        ></span>
        Save
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
